
/* Sx cpu micro architecture simulator

   5 December 2001
   modify from s2m sim
   Computer Architecture 1997, 1998
   microprogram version 		13 Feb 2005

   sx micro						10 July 2006
   sx0  minimum version			11 July 2006

   P. Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University
*/

#define  endProg	113

#include "sx.h"

int icnt[200]; 		// instruction counter

void trace(void){
	icnt[PC]++;
}

void report(void){
	int i, s;
	s = 0;
	for(i=1; i<endProg; i++){
		s += icnt[i];
		printf("%d %d\n",icnt[i],i);
	}
	printf("total %d instructions\n",s);
}

void run(void){
	while(runflag) {
//		printf("%d ",PC);
//		trace();
		run3();
		ninst++;
		if(ninst > 1000000) break;
	}
}

void initchip(void){
	clock = 0;
	ninst = 0;
	runflag = 1;
	TS = 0;
	NX = 0;
	FF = 0;
	FP = SSBASE;
	SP = SSBASE;
	PC = 1;
	Z = 0;
	S = 0;
	mpc = 0;
}

int main(int argc, char *argv[]){
  if( argc < 2 ) {
    printf("usage : sx objfile\n");
    exit(0);
  }
  loadobj(argv[1]);
  initchip();
  run();
//  report();
  return 0;
}

